<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { NextStep } from '~/components/common/index.vue';
import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import {
  CodeSuggestionsSalesContent,
  CodeSuggestionsSalesHero,
} from '~/components/solutions/code-suggestions/sales/index.vue';
import { GDSAlesHelper } from '~/services/solutions/gitlab-duo-sales.service';

export default {
  name: 'CodeSuggestions',
  components: {
    NextStep,
    CodeSuggestionsSalesContent,
    CodeSuggestionsSalesHero,
    SolutionsResourceCards,
  },

  layout: 'duo-pro-sm-and-dedicated-sales',
  nuxtI18n: false,

  async asyncData() {
    try {
      const content = await getClient()
        .getEntries({
          content_type: CONTENT_TYPES.PAGE,
          include: 10,
          'fields.slug':
            'solutions/gitlab-duo-pro/self-managed-and-gitlab-dedicated-trial',
        })
        .then((query: any) => {
          const entryFields = query.items[0]?.fields;
          return GDSAlesHelper(entryFields);
        });
      return { content };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      submitted: false,
    };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata((this as any).content, this.$route.path),
    };
  },
  methods: {
    onFormSubmit() {
      this.$nuxt.$emit('submit');
      this.submitted = true;
      this.$refs.targetRef.scrollIntoView({ behavior: 'smooth' });
    },
  },
};
</script>
<template>
  <div ref="targetRef" class="code-suggestions-sales">
    <TransitionGroup name="content" tag="div">
      <CodeSuggestionsSalesHero
        v-if="!submitted && content.hero"
        key="hero"
        :data="content.hero"
      />
      <CodeSuggestionsSalesContent
        v-if="!submitted"
        key="content"
        :video="content.video"
        :data="content.textBlock"
        :form="content.form"
        :button="content.button"
        @submit="onFormSubmit"
      />
    </TransitionGroup>
    <TransitionGroup name="content" tag="div">
      <CodeSuggestionsSalesHero
        v-if="submitted && content.submittedHero"
        key="hero"
        :data="content.submittedHero"
      />
      <SolutionsResourceCards
        v-if="submitted && content.resources"
        v-bind="content.resources"
        key="resources"
      />
    </TransitionGroup>
    <NextStep :variant="content?.nextSteps" />
  </div>
</template>

<style lang="scss" scoped>
.code-suggestions-sales {
  overflow: hidden;
}
.content-move, /* apply transition to moving elements */
.content-enter-active,
.content-leave-active {
  transition: all 0.5s ease;
}

.content-enter-from,
.content-leave-to {
  opacity: 0;
}
.content-leave-to {
  transform: translateY(100%);
}
/* ensure leaving items are taken out of layout flow so that moving
   animations can be calculated correctly. */
.content-leave-active {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
}
</style>
